﻿// ----------------------------------------------------------------------------------------
//
// JoyTest                                                        Ulrich Müller 04.02.10
//                                                                Aspire C# 2008 Express
// Erproben der Eigenschaften des angeschlossenen Joysticks
// 
// ----------------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;
using System.Threading;
using System.Windows.Forms;

namespace JoyTest {
  public partial class JoyMain : Form {

    # region --- Joystick Definitionen -----------
    [DllImport("winmm.dll")]
    private static extern uint joyGetPosEx(uint uJoyID, ref JoyInfoEx ji);

    private const uint JOYERR_NOERROR = 0;
    private const uint JoyReturnButtons = 0x80;
    private const uint JoyReturnCentered = 0x400;
    private const uint JoyReturnPOV = 0x40;
    private const uint JoyReturnR = 0x8;
    private const uint JoyReturnU = 0x10;
    private const uint JoyReturnV = 0x20;
    private const uint JoyReturnX = 0x1;
    private const uint JoyReturnY = 0x2;
    private const uint JoyReturnZ = 0x4;
    private const uint JoyReturnAll = JoyReturnX | JoyReturnY | JoyReturnZ
                                         | JoyReturnR | JoyReturnU | JoyReturnV
                                         | JoyReturnPOV | JoyReturnButtons;
    private struct JoyInfoEx {
      public uint dwSize;
      public uint dwFlags;
      public uint dwXpos;
      public uint dwYpos;
      public uint dwZpos;
      public uint dwRpos;
      public uint dwUpos;
      public uint dwVpos;
      public uint dwButtons;
      public uint dwButtonNumber;
      public uint dwPOV;
      public uint dwReserved1;
      public uint dwReserved2;
    }
    # endregion

    private JoyInfoEx ji = new JoyInfoEx();
    private bool NotHalt = false;
    public JoyMain() {
      InitializeComponent();
    }
    private void cmdEnde_Click(object sender, EventArgs e) {
      NotHalt = true;
      cmdEnde.Text = "ENDE";
      Application.DoEvents();
    }

    private void cmdAction_Click(object sender, EventArgs e) {
      ji.dwSize       = 52;
      ji.dwFlags      = JoyReturnAll;
      lblHinweis.Text = "Beenden durch HALT-BUTTON";

      while (!NotHalt) {       
        if (joyGetPosEx(0, ref ji) != JOYERR_NOERROR) {
          lblHinweis.Text = "Kein Joystick da";
          return;
        }
        lblR.Text = ji.dwButtons.ToString();
        lblX.Text = ji.dwXpos.ToString();
        lblY.Text = ji.dwYpos.ToString();
        lblZ.Text = ji.dwZpos.ToString();

        Application.DoEvents();
        Thread.Sleep(12);
      }
      lblHinweis.Text = "Das war's";
      Application.DoEvents();
      this.Close();
    }

  }
}
