﻿' -----------------------------------------------------------------------------------------
'
' TxExplorerVBdeLuxe                                                Ulrich Müller  06.02.10
'                                                                   Aspire  VB 2008 Express
' ROBO TX Trainings Lab : Betrieb des Basismodells mit JoyStick (über winmm.dll)
'                         Rechtes Rad an M1, Linkes Rad an M2
'                         Scheinwerfer an M4, Photowiderstand an I1, Blaulicht an M3
'                         Basis FishFaceTX.DLL
'
' -----------------------------------------------------------------------------------------

Option Explicit On
Option Strict Off
Imports System.Threading
Imports FishFaceTX

Module TxExplorerVBdeLuxe
  Structure FahrAuftrag
    Public rDir   As Dir
    Public rSpeed As Integer
    Public lDir   As Dir
    Public lSpeed As Integer
    Sub New(ByVal rD As Dir, ByVal rS As Integer, ByVal lD As Dir, ByVal lS As Integer)
      rDir   = rD
      rSpeed = rS
      lDir   = lD
      lSpeed = lS
    End Sub
  End Structure

  Dim tx          As New FishFace()
  Dim fa(3, 3)    As FahrAuftrag
  Dim ji          As New JoyInfoEx()
  Dim blinkThread As Thread
  Dim Blinken     As Boolean = False

  Const mRechteRaupe As Mot = Mot.M1
  Const mLinkeRaupe  As Mot = Mot.M2
  Const dVor         As Dir = Dir.Left
  Const dRuck        As Dir = Dir.Right
  Const SpeedOff     As Integer = 0
  Const SpeedFull    As Integer = 8
  Const SpeedHalf    As Integer = 6
  Const uPhotoW      As Unv = Unv.I1
  Const oBlauL       As Out = Out.O5
  Const oLampen      As Out = Out.O7
  Const LampenAn     As Integer = 555
  Const LampenAus    As Integer = 500

#Region "--- Joystick Definitionen ---"
  Private Declare Function joyGetPosEx Lib "winmm.dll" _
  (ByVal uJoyID As UInteger, ByRef ji As JoyInfoEx) As UInteger
  Private Const JOYERR_NOERROR As UInteger = 0
  Private Const JoyReturnButtons As UInteger = &H80
  Private Const JoyReturnCentered As UInteger = &H400
  Private Const JoyReturnPOV As UInteger = &H40
  Private Const JoyReturnR As UInteger = &H8
  Private Const JoyReturnU As UInteger = &H10
  Private Const JoyReturnV As UInteger = &H20
  Private Const JoyReturnX As UInteger = &H1
  Private Const JoyReturnY As UInteger = &H2
  Private Const JoyReturnZ As UInteger = &H4
  Private Const JoyReturnAll As UInteger = JoyReturnX Or JoyReturnY Or JoyReturnZ _
  Or JoyReturnR Or JoyReturnU Or JoyReturnV Or JoyReturnPOV Or JoyReturnButtons

  Private Structure JoyInfoEx
    Public dwSize As UInteger
    Public dwFlags As UInteger
    Public dwXpos As UInteger
    Public dwYpos As UInteger
    Public dwZpos As UInteger
    Public dwRpos As UInteger
    Public dwUpos As UInteger
    Public dwVpos As UInteger
    Public dwButtons As UInteger
    Public dwButtonNumber As UInteger
    Public dwPOV As UInteger
    Public dwReserved1 As UInteger
    Public dwReserved2 As UInteger
  End Structure
#End Region
#Region "--- ProgramControl ---"
  Sub Main()
    fa(0, 0) = New FahrAuftrag(dVor,  SpeedFull, dVor, SpeedHalf)
    fa(0, 1) = New FahrAuftrag(dVor,  SpeedHalf, dRuck, SpeedHalf)
    fa(0, 2) = New FahrAuftrag(dRuck, SpeedHalf, dRuck, SpeedFull)

    fa(1, 0) = New FahrAuftrag(dVor,    SpeedFull, dVor, SpeedFull)
    fa(1, 1) = New FahrAuftrag(Dir.Off, SpeedOff,  Dir.Off, SpeedOff)
    fa(1, 2) = New FahrAuftrag(dRuck,   SpeedFull, dRuck, SpeedHalf)

    fa(2, 0) = New FahrAuftrag(dVor,  SpeedHalf, dVor, SpeedFull)
    fa(2, 1) = New FahrAuftrag(dRuck, SpeedHalf, dVor, SpeedHalf)
    fa(2, 2) = New FahrAuftrag(dRuck, SpeedHalf, dRuck, SpeedFull)

    Try
      tx.OpenController("COM25")
      Console.WriteLine("--- Bei der Arbeit, Abbruch ESC-Taste ---")
      ji.dwSize = 52
      ji.dwFlags = JoyReturnAll
      blinkThread = New Thread(AddressOf executeBlinken)
      blinkThread.IsBackground = True
      blinkThread.Start()

      Action()

    Catch ex As FishFaceException
      Console.WriteLine(ex.Message)
    Finally
      tx.CloseController()
      Console.WriteLine("--- FINITO : RETURN drücken ---")
      Console.Read()
    End Try
  End Sub
#End Region

  Sub Action()
    Dim xFa, yFa, zFa, hell As Integer
    Do
      If joyGetPosEx(0, ji) <> JOYERR_NOERROR Then
        Console.Write("Kein JoyStick da")
        Return
      End If
      xFa = ji.dwXpos / 29000
      yFa = ji.dwYpos / 29000
      zFa = 32 - (ji.dwZpos / 2048)
      tx.SetMotor(mRechteRaupe, fa(xFa, yFa).rDir, fa(xFa, yFa).rSpeed * zFa + 256)
      tx.SetMotor(mLinkeRaupe,  fa(xFa, yFa).lDir, fa(xFa, yFa).lSpeed * zFa + 256)
      If (ji.dwButtons And &H2) > 0 Then
        Do
          tx.Pause(55)
          joyGetPosEx(0, ji)
        Loop While (ji.dwButtons And &H4) > 0
        If Blinken Then Blinken = False Else Blinken = True
      End If
      hell = tx.GetAnalog(uPhotoW)
      If hell > LampenAn Then
        tx.SetLamp(oLampen, Dir.On)
      ElseIf hell < LampenAus Then
        tx.SetLamp(oLampen, Dir.Off)
      End If
      tx.Pause(123)
    Loop Until tx.Finish()
  End Sub

  Sub executeBlinken()
    Do Until tx.Finish()
      If Blinken Then
        tx.SetLamp(oBlauL, Dir.On)
        Thread.Sleep(444)
        tx.SetLamp(oBlauL, Dir.Off)
        Thread.Sleep(333)
      Else
        tx.SetLamp(oBlauL, Dir.Off)
        Thread.Sleep(333)
      End If
    Loop
  End Sub
End Module
